//Doit stocker les differentes modification sous forme fichier texte
//lire le port serie 
//ecrire sur le port serie
#include <SPI.h>
#include <SD.h>
#include <RFduinoBLE.h>

File myFile, mytmp;
const char* test = "test.txt";
const char* tmp = "TMP.txt";
const char* frigo = "frigolist.txt";


void init_sd()
{
  Serial.begin (9600);
  while (!Serial)
  {
  }
  Serial.print("Initialisation de la Carte SD\n");
  if (!SD.begin(6))
  {
    Serial.print("Echec de l'initialisation\n ");
    return;
  }
  Serial.print("Initialisation reussie\n");
  if (SD.exists("frigolist.txt")) 
  {
      Serial.println("frigolist.txt exists. \n");
    } 
    else 
    {
      Serial.println("frigolist.txt doesn't exist.");
      Serial.println("Creating frigolist.txt...");
      if ((myFile = SD.open("test.txt", FILE_WRITE)) == false) {Serial.println("Erreur Creation");}
      myFile.close();
    }
}
//         heure mmhhjjmmyy char30  jjmmyy  total = 10 + 30 +6 + 2speciau
//                48 caractere + EOS(\0) = 49                 


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
///////////////////////////////////////////////////////////////////       Fonctions Elementaire traitement de Texte     //////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////




long count_line(char** designation) // designation max 30 taille pas de depassement memoire
{
  myFile = SD.open("test.txt", FILE_READ);
  String Designation = String(*designation);
  String line;
  char ligne[30];
  int i = 0;
  unsigned long pos = 0;
  //Serial.print("Var\n");
  if (myFile.available())
  {
    do
    {
      while(myFile.read() != '#'){}
      while (myFile.peek() != '#')
      {
       ligne[i] = myFile.read();
       i++;
      }
      ligne[i] = '\0';
      pos = myFile.position() - i - 11;
      i = 0;
      //Serial.println(ligne);
      while(myFile.read() != '\n'){}
      line = String(ligne);
    } while (Designation.compareTo(ligne));
  }
    myFile.close();
    return pos;
}



int str_len( char str[])
{
  int i = 0;
  while (str[i] != '\0')
  {
    i++;
  }
  return i;

}

void lecture(const char* file)                                 // Lit le contenu d'un fichier
{
  myFile = SD.open(file, FILE_READ);
    while(myFile.available())
    {
      Serial.write(myFile.read());
    }
  myFile.close();
  
}

void copie(const char* source, const char* dest)              // Copie d'un fichier source à une destination
{
  File mySource = SD.open(source, FILE_READ);
  File myDest = SD.open(dest, FILE_WRITE);
  while(mySource.available())
  {
    myDest.write(mySource.read());
  }
  mySource.close();
  myDest.close();
}


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////     Modification Liste !       /////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////





void ajout(char *ligne) //ligne sans '\n' ajouter par println
{
  myFile = SD.open("test.txt", FILE_WRITE);
  myFile.seek(myFile.size()); // Positionnement fin de fichier
  myFile.write(ligne);     // ecriture de l'objet string (c89)
  myFile.close();
}



void update(char* date)
{
  myFile = SD.open("test.txt", FILE_READ);     // heure mmhhjjmmyy#char30#jjmmyy\n  total = 10 + 30 +6 + 2speciau +1  39 carac 
  String Date = String(date);
  String Line;
  char ligne[30];
  unsigned long pos = 0;
  int i = 0;
  if (myFile.available())
  {
    do
    {
      while(myFile.peek() != '#')             //Ajout char by char a la chaine ligne 
      {                                       // Jusqu'a la présence de '#' dans le buffer
        ligne[i] = myFile.read();
        i++;
      }
      ligne[i] = '\0';                          // Ajout du caractere de fin de chaine
      pos = myFile.position() - i;
      i = 0;
      Line = String(ligne);
      while(myFile.read() != '\n') {}
    } while (Date >= Line);                 // Tant que la date renseigner par le téléphone est plus récente
    if (Date <= Line)                       // que la date lu dans le fichier
    {
        myFile.seek(pos);
        while(myFile.available())          // Envoie du contenue plus récent que sur le téléphone
        {
          Serial.write(myFile.read());
        }
    }
  }
}



void retrait(char* designation)
{
  
  unsigned long pos = count_line(&designation);
  if (SD.exists(tmp)) {SD.remove(tmp);}
  myFile = SD.open(test, FILE_READ);
  delay(100);
  mytmp = SD.open(tmp, FILE_WRITE);
  delay(500);
  //Serial.println(pos);
  int i = 0;
  while (i < pos)                     // Copie du texte avant la ligne a supprimer
  {
    mytmp.write(myFile.read());
    i++;
  }
  while (myFile.read() != '\n') {}
  while(myFile.available())           // Reste du texte a copier
  {
    mytmp.write(myFile.read());
  }
  myFile.close();
  mytmp.close();
  SD.remove(test);
  copie(tmp, test);
}

void RFduinoBLE_onReceive(char *data, int len) // Lorsqu'on reçoit de la data
{
                        // Le telephone attend le carac NUL de retour
  if (data[0] == 'a')     //Update case
  {
    ajout(data+1);
    RFduinoBLE.send('NUL');
  }
  if (data[0] == 'r')
  {
    update(data+1);
    RFduinoBLE.send('NUL');
  }
  if (data[0] == 'u')
  {

    RFduinoBLE.send('NUL');
  }
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////    FONCTION ARDUINO !       /////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////






void setup()
{
  
  Serial.println("Initialisation de la carte SD");
  init_sd();
  SD.remove(test);
  SD.remove(tmp);
  
  //RFduinoBLE.deviceName = "Frigidee";
  //RFduinoBLE.begin();
  char* date1 = "1302010235#Beurre#02032016\n"; // 01/02/2016 02:35
  char* date2 = "1402021000#Fromage#02032016\n";
  char* date3 = "1602010234#Pain#02032016\n";
  //SD.remove(test);
  Serial.println("Ajout de texte");
  ajout(date1);
  ajout(date2);
  ajout(date3);
  Serial.println("Lecture du contenu du fichier\n");
  lecture(test);
  Serial.println("\nSimulation d'en voie de la date 15221000 par le SP\n");
  update("1502021000");
  Serial.println("\nRetrait de la ligne 'Fromage'\n");
  retrait("Fromage");
  Serial.println("action : Lecture\n");
  lecture(test);
  
}

void loop()
{
  // Attente d'une reception série
  RFduino_ULPDelay(INFINITE);
}

